#include <memory.h>

void* mem_start;
void* mem_ptr;
int blocks = 0;

struct limine_kernel_address_request kernel_address_request = {
	.id = LIMINE_KERNEL_ADDRESS_REQUEST,
	.revision = 0
};

struct limine_kernel_address_response* kernel_address = { 0 };

void mem_init() {
	kernel_address = kernel_address_request.response;
}

void mem_add(uint64_t base, uint64_t len) {
	if(!mem_start) {
		mem_start = mem_ptr = (void*)kernel_address->virtual_base + base;
		*((struct mem_desc*)mem_start) = (struct mem_desc) {
			.base = base,
			.len = len
		};
		mem_ptr += sizeof(struct mem_desc);
		blocks++;
	}
}

void* mem_alloc(size_t sz) {
	void* start = mem_ptr;
	*((size_t*)start) = sz;
	mem_ptr += sz + sizeof(size_t);
	return start + sizeof(size_t);
}
