#include <printf.h>
#include <string.h>
#include <stdlib.h>
#include <terminal.h>
#include <flanterm/flanterm.h>
#include <ctype.h>

void putc(char ch) {
	flanterm_write(ft_ctx, &ch, 1);	
}

void puts(const char* str) {
	flanterm_write(ft_ctx, str, strlen(str));
}

void printf(const char *str, ...) {
	va_list list;
	va_start(list, str);

	char buf[128];

	for(int i = 0; str[i] != '\0'; i++)
	{
		switch(str[i])
		{
		case '%':
			i++;

			size_t width = 0;
			char padding_char = str[i];
			if(isdigit(str[i]) || str[i] == ' ') {
				i++;
				int pos = 0;
				while(isdigit(str[i])) {
					buf[pos++] = str[i++];
				}
				buf[pos] = '\0';
				width = atoi(buf);
			}

			const char* out = 0;

			if(str[i] == 's')
				out = va_arg(list, const char*);
			if(str[i] == 'd')
				out = itoa(va_arg(list, int), buf, 10);
			if(str[i] == 'u')
				out = ultoa(va_arg(list, uint64_t), buf, 10);
			if(str[i] == 'x')
				out = ultoa(va_arg(list, uint64_t), buf, 16);
			if(str[i] == 'c')
				putc(va_arg(list, int));

			size_t len = strlen(out);
			if(width > len) {
				char padding[256];
				size_t j = 0;
				for(; j < width - len; j++)
					padding[j] = padding_char;
				padding[j] = '\0';
				puts(padding);
			}

			puts(out);
			break;
		default:
			putc(str[i]);
			break;
		}
	}

	va_end(list);
}
